/*
 * The contents of this file are subject to the Netscape Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation.  All Rights
 * Reserved.
 *
 * Contributor(s):
 *   EVM-Group <evm@s3.uni-essen.de>
 */


// **************************************************************************
// ********************** EVM-SEARCH-XUL Functions **************************
// **************************************************************************
// +++ EVM window search functions +++
// * for English description please read functions' prologues
//
// function evmCheckButtonStates()
// function evmGetNumRows()
// function evmSearchRemoveSearchRow()
// function evmSearchNewSearchRow(selField,selCriteria,text)
// function evmSearchGeneratePseudocode()
// function evmSearchGeneratePseudocodeArr()
// function evmSearchIsEntryStringOrNumber(pruef,connection)
// function evmCheckForInnerRules(s)
// function evmSearchGenerateGetSQL(pseudocode,zweiterCheck)
// function evmSearchBuildMask(pseudocode)
// function evmSearchParsePseudocode(pseudocode)
// function evmSearchGetMenuItem(label,value,id)
// function evmSearchGetCriteriaMenulist(selCriterium)
// function evmSearchGetFieldMenulist(selField)
// function evmClearDropDown()
// function evmSearchcreateDropdown()
// function evmSearchButtonSave()
// function evmSearchClearSearchRows()
// function evmSearchFieldDropdownEvent()
// function evmSearchReset()
//
// **************************************************************************
// Version: 18.02.2004 (Tim Franz, Kai Henning, Andr Grothues)
// **************************************************************************


  // *************************************************************************
  // function:		checkButtonStates()
  // status:		finished
  // author:		Tim Franz
  // *************************************************************************
  // checks whether removeSearchRow-Button can be removed or not
  function checkButtonStates()
  {
    if(getNumRows() == 1)
    {
      btn = document.getElementById("evm-search-btn-removeSearchRow");
      btn.setAttribute("disabled",true);
    }
    if(getNumRows() > 1)
    {
      btn = document.getElementById("evm-search-btn-removeSearchRow");
      btn.setAttribute("disabled",false);
    }
  }


  // *************************************************************************
  // function:		getNumRows()
  // status:		finished
  // author:		Tim Franz
  // *************************************************************************
  // returns the number of search rows
  function getNumRows()
  {
    var parentbox = document.getElementById("superbox");
    var numRows = parentbox.childNodes.length;
    return numRows;
  }


  // *************************************************************************
  // function:		evmSearchRemoveSearchRow()
  // status:		finished
  // author:		Tim Franz
  // *************************************************************************
  // removes the last search row
  function evmSearchRemoveSearchRow()
  {
    var parentbox = document.getElementById("superbox");
    if(getNumRows() > 1)
    {
      parentbox.removeChild(parentbox.lastChild);
    }
    checkButtonStates();
  }


  // *************************************************************************
  // function:		evmSearchNewSearchRow(selField, selCriteria, text)
  // status:		finished
  // author:		Tim Franz / Kai Henning
  // *************************************************************************
  // creates a new search row: fieldlist, criterialist and textbox
  function evmSearchNewSearchRow(selField, selCriteria, text)
  {
    var elementCount = getNumRows()+1;
    var searchmnlst = document.createElement("menulist");
    searchmnlst.setAttribute("id","fieldlist-"+elementCount);
    searchmnlst.setAttribute("oncommand","evmSearchFieldDropdownEvent();");
    searchmnlst.appendChild(evmSearchGetFieldMenulist(selField));

    var smLogicalOperatorMenu = document.createElement("menulist");
    smLogicalOperatorMenu.setAttribute("id","criterialist-" + elementCount);
    smLogicalOperatorMenu.appendChild(evmSearchGetCriteriaMenulist(selCriteria));

    var searchmenuinput = document.createElement("textbox");
    searchmenuinput.setAttribute("id","searchtext-" + elementCount);
    searchmenuinput.setAttribute("flex",1);
    searchmenuinput.setAttribute("style","min-width: 100px;");
    if(text === undefined)
    {
      searchmenuinput.setAttribute("value", "");
    }
    else
    {
       searchmenuinput.setAttribute("value", text);
    }

    var searchrow = document.createElement("hbox");
    searchrow.setAttribute("id","searchrow");

    searchrow.appendChild(searchmnlst);
    searchrow.appendChild(smLogicalOperatorMenu);
    searchrow.appendChild(searchmenuinput);

    var parentbox = document.getElementById("superbox");
    parentbox.appendChild(searchrow);

    checkButtonStates();
  }


  // *************************************************************************
  // function:		evmSearchGeneratePseudocode()
  // status:		finished
  // author:		Tim Franz
  // *************************************************************************
  // returns pseudocode from a searchword array
  function evmSearchGeneratePseudocode()
  {
    var arrCode = evmSearchGeneratePseudocodeArr();
    if (arrCode == null) return;
    var inText="";
    arrRow = arrCode[1];
    inText += arrRow[0] + "|" + arrRow[1] + "|" + arrRow[2];
    if(arrCode.length > 2)
    {
      for (var i=2; i < arrCode.length; i++)
      {
        arrRow = arrCode[i];
        inText +="|||" + arrRow[0] + "|" + arrRow[1] + "|" + arrRow[2];
      }
      inText = arrCode[0]+'|||' + inText;
    }
    return inText;
  }


  // *************************************************************************
  // function:		evmSearchGeneratePseudocodeArr()
  // status:		finished
  // author:		Tim Franz / Kai Henning
  // *************************************************************************
  // returns array of pseudocode of the searchword controls
  function evmSearchGeneratePseudocodeArr()
  {
    var arrCode = new Array();
    arrCode[0] = document.getElementById("evm-search-connection").selectedItem.value;
    for (var i=1; i <= getNumRows(); i++)
    {
      var arrTmp = new Array();
      arrTmp[0] = document.getElementById("fieldlist-"+i).value;
      if(arrTmp[0].indexOf("evmRule") == 0)
      {
        arrTmp[1] = "47evm11";
        arrTmp[2] = " ";
      }
      else
      {
        arrTmp[1] = document.getElementById("criterialist-"+i).value;
        arrTmp[2] = document.getElementById("searchtext-"+i).value;
        if (arrTmp[2] == "") return;
      }
      arrCode[i] = arrTmp;
    }
    return arrCode;
  }


  // *************************************************************************
  // function:		evmSearchIsEntryStringOrNumber(pruef,connection)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // if the parameter pruef contains a string, we need apostrophs for making
  // the DB query -> parsing error otherwise
  function evmSearchIsEntryStringOrNumber(pruef,connection)
  {
	if(evmIsInteger(pruef) == false)
	{
	  if(connection.toLowerCase().indexOf("like") >= 0) pruef = "%" + pruef + "%";
	  return "'" + pruef + "'";
	}
  }


  // *************************************************************************
  // function:		evmCheckForInnerRules(s)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // if a rule is re-used in another rule, we need to replace keywords using
  // sql-strings
  // rules containing inner rules look, for example, like this:
  //   (_X_evmRule<innerRuleName>_X_) AND (subject LIKE '%whatever%')
  function evmCheckForInnerRules(s)
  {
    if(s.indexOf("evmRule") < 0) return s;
    evmInitConnection();
    erroroccured = false;
    while(s.indexOf("evmRule") >= 0 && erroroccured == false)
    {
      var t = s.split("_X_"); 		// we at least get three parts out of that: "(", the rulename, and the rest-string
      var id = t[1].split("Rule"); // id[0] contains "evm", id[1] the rulename as stored in DB
      try
      {
        query = "select id, searchstring from search where (name ='" + id[1] + "')";
        result = connection.executeQuery(query);
      }
      catch(ex) { }
      try
      {
        if(evmIsEntryAvailableInDB(result))
        {
          if (result.rowCount >= 0)
          {
            var enumerator = result.enumerate();
            enumerator.first();
            var translatedquery = evmSearchGenerateGetSQL(enumerator.getVariant(1),false);
		    var neu = t[0] + translatedquery;
		    for(var j = 2; j < t.length; j++)
		    {
		      neu = neu + t[j];
		      if(j < t.length-1) neu = neu + "_X_";
		    }
		    s = neu;
		  }
		  else erroroccured = true;
        }
        else erroroccured = true;
      }
      catch(ex) { }
    } // while
    return s;
  }


  // *************************************************************************
  // function:		evmSearchGenerateGetSQL(pseudocode,zweiterCheck)
  // status:		finished
  // author:		Tim Franz, Kai Henning
  // *************************************************************************
  // returns SQL-String out of a pseudocode-String
  // this functions gets a 2-dimensional array from the function evmSearchParsePseudocode(pseudocode)
  // and creates a SQL string (inner rules are put into "_X_", necessary for function evmCheckForInnerRules(s))
  // Please note: the parameter zweiterCheck is there only to avoid recursion from the function
  //  evmCheckForInnerRules(s) cuz we really do not want it then...
  function evmSearchGenerateGetSQL(pseudocode,zweiterCheck)
  {
    var codeArr = evmSearchParsePseudocode(pseudocode);
    var strSQL = "";
    var startIndex=0;
    var connectOperator = "AND";
    if(codeArr[0].length == 1)
    {
        startIndex = 1;
        connectOperator = codeArr[0];
    }

    if(codeArr[startIndex][1] == "47evm11")
    {
      strSQL = "(_X_" + codeArr[startIndex][0] + "_X_)";
    }
    else strSQL += "(" + codeArr[startIndex][0] + " " + codeArr[startIndex][1] + " " + evmSearchIsEntryStringOrNumber(codeArr[startIndex][2],codeArr[startIndex][1]) + ")";
    if(codeArr.length > startIndex + 1)
    {
      for (var i=startIndex+1; i < codeArr.length; i++)
      {
        if(codeArr[i][1] == "47evm11")
        {
          strSQL += " " + connectOperator + " (_X_" + codeArr[i][0] + "_X_)";
        }
        else strSQL += " " + connectOperator + " " + "(" + codeArr[i][0] + " " + codeArr[i][1] + " " + evmSearchIsEntryStringOrNumber(codeArr[i][2],codeArr[startIndex][1]) + ")";
      }
    }
	if(zweiterCheck == true) strSQL = evmCheckForInnerRules(strSQL);
    return strSQL;
  }


  // *************************************************************************
  // function:		evmSearchBuildMask(pseudocode)
  // status:		finished
  // author:		Tim Franz
  // *************************************************************************
  // builds the searchform out of a given pseudocode-string
  function evmSearchBuildMask(pseudocode)
  {
    var codeArr = evmSearchParsePseudocode(pseudocode);
    var startIndex=0;
    document.getElementById("evm-search-connection").selectedItem = document.getElementById("evm-search-connection-or");
    if(codeArr[0].length == 1)
    {
      startIndex=1;
      document.getElementById("evm-search-connection").selectedItem = document.getElementById("evm-search-connection-"+codeArr[0]);
    }
    for (var i=startIndex; i < codeArr.length; i++)
    {
      evmSearchNewSearchRow(codeArr[i][0],codeArr[i][1],codeArr[i][2]);
    }
  }


  // *************************************************************************
  // function:		evmSearchParsePseudocode(pseudocode)
  // status:		finished
  // author:		Tim Franz
  // *************************************************************************
  // returns an array with the single tokens iof the pseudocode-term
  function evmSearchParsePseudocode(pseudocode)
  {
    var dingens = pseudocode.split("|||");
    for (var i=0; i < dingens.length; i++)
    {
      var dangens = dingens[i].split("|");
      dingens[i] = dangens;
    }
    return dingens;
  }


  // *************************************************************************
  // function:		evmSearchGetMenuItem(label, value,id)
  // status:		finished
  // author:		Tim Franz
  // *************************************************************************
  // generates menuitem
  function evmSearchGetMenuItem(label, value,id)
  {
    op  = document.createElement("menuitem");
    op.setAttribute("label",label);
    op.setAttribute("value",value);
    op.setAttribute("id",id);
    return op;
  }


  // *************************************************************************
  // function:		evmSearchGetCriteriaMenulist(selCriterium)
  // status:		finished
  // author:
  // *************************************************************************
  // generates menupopup with list of searchcriteria
  function evmSearchGetCriteriaMenulist(selCriterium)
  {
    var mnu = document.createElement("menupopup");

    c = evmSearchGetMenuItem("contains","LIKE","criteria-contains");
    mnu.appendChild(c);
    c = evmSearchGetMenuItem("contains not","NOT LIKE","criteria-containsnot");
    mnu.appendChild(c);
    c = evmSearchGetMenuItem("equals","=","criteria-equals");
    mnu.appendChild(c);
    c = evmSearchGetMenuItem("equals not","<>","criteria-equalsnot");
    mnu.appendChild(c);
    c = evmSearchGetMenuItem("<=","<=","criteria-lesserorequal");
    mnu.appendChild(c);
    c = evmSearchGetMenuItem("<","<","criteria-lesser");
    mnu.appendChild(c);
    c = evmSearchGetMenuItem(">=",">=","criteria-greaterorequal");
    mnu.appendChild(c);
    c = evmSearchGetMenuItem(">",">","criteria-greater");
    mnu.appendChild(c);

    // get active element
    for(var i = 0; i < mnu.childNodes.length; i++)
    {
      var c = mnu.childNodes[i];
      if(c.getAttribute("value") == selCriterium)
      {
        c.setAttribute("selected","true");
      }
    }
    return mnu;
  }


  // *************************************************************************
  // function:		evmSearchGetFieldMenulist(selField)
  // status:		finished
  // author:		Tim Franz, Kai Henning
  // *************************************************************************
  // generates menupopup with list of searchfields and existing rules
  function evmSearchGetFieldMenulist(selField)
  {
    var mnu = document.createElement("menupopup");

    c = evmSearchGetMenuItem("Subject","subject","field-subject");
    mnu.appendChild(c);
     c = evmSearchGetMenuItem("Body","body","field-body");
    mnu.appendChild(c);
     c = evmSearchGetMenuItem("Category","category","field-category");
    mnu.appendChild(c);
     c = evmSearchGetMenuItem("Sender","sender","field-author");
    mnu.appendChild(c);
     c = evmSearchGetMenuItem("Date","date","field-date");
    mnu.appendChild(c);
     c = evmSearchGetMenuItem("To","to","field-to");
    mnu.appendChild(c);
     c = evmSearchGetMenuItem("CC","cc","field-cc");
     mnu.appendChild(c);

    var query = "SELECT name, id FROM search ORDER BY childof, name";
    try
    {
      var result = connection.executeQuery(query);
    }
    catch(ex) { }
    try
    {
      if (result.rowCount >= 0)
      {
        var enumerator = result.enumerate();
        enumerator.first();
        for(var i = 1; i <= result.rowCount; i++)
        {
    	  c = evmSearchGetMenuItem(enumerator.getVariant(0),"evmRule"+enumerator.getVariant(0),"evmRuleID"+enumerator.getVariant(1));
     	  mnu.appendChild(c);
          if (i < result.rowCount)
	      {
	        enumerator.next();
	      }
        }
      }
    }
    catch(ex)
    {
    }

    for(var i = 0; i < mnu.childNodes.length; i++)
    {
      var c = mnu.childNodes[i];
      if(c.getAttribute("value") == selField)
      {
        c.setAttribute("selected","true");
      }
    }
    return mnu;
  }


  // *************************************************************************
  // function:		evmSearchGetUID(e)
  // status:		?
  // author:		Tim Franz
  // *************************************************************************
  //
  function evmSearchGetUID(e)
  {
    return "evmsearch-"+e+"1";
  }


  // *************************************************************************
  // function:		evmClearDropDown()
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // clears the dropdownbox for choosing parent search
  function evmClearDropDown()
  {
    try
    {
      var menupopup = document.getElementById("evm-search-searchcategory-menupopup");
      while (menupopup.firstChild!=null)
        menupopup.removeChild(menupopup.firstChild);
    }
    catch(err)
    {}
  }


  // *************************************************************************
  // function:		evmSearchcreateDropdown()
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // creates the dropdownbox for choosing parent search
  function evmSearchcreateDropdown()
  {
    evmClearDropDown();
    var tree = document.getElementById("evmEVMWindowMailviewFolderpaneboxSearchtree");
    var menupopup = document.getElementById("evm-search-searchcategory-menupopup");
    try
    {
      var index = 0;
      var menuitem = document.createElement("menuitem");
      menuitem.setAttribute("id","");
	  menuitem.setAttribute("DBid","");
      menuitem.setAttribute("label","ROOT");
      menupopup.appendChild(menuitem);

      while (tree.treeBoxObject.view.getItemAtIndex(index)!=null)
      {
        var current = tree.treeBoxObject.view.getItemAtIndex(index);
	    var currentlevel = tree.treeBoxObject.view.getLevel(index);
	    var menuitem = document.createElement("menuitem");
	    menuitem.setAttribute("id","dropdown" + current.getAttribute("id"));
	    menuitem.setAttribute("DBid",current.getAttribute("id"));
	    var name = "";
	    for (var x=0; x<=currentlevel; x++) name = name + "     ";
	    var cellcontent = tree.treeBoxObject.view.getCellText(index,"evmEVMWindowMailviewFolderpaneboxSearchtree");
	    name = name + cellcontent;
	    menuitem.setAttribute("label",name);
	    menupopup.appendChild(menuitem);
	    index++;
      }
    }
    catch(err)
    {
    }
  }


  // *************************************************************************
  // function:		evmSearchButtonSave()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // button functionality for saving search queries
  function evmSearchButtonSave()
  {
    if (evmSearchGeneratePseudocode()==null)
    {
      alert("Some values are not entered!");
      return;
    }

    var sql_text = document.getElementById("evm-search-textbox-query");
    try{sql_text.setAttribute("value",evmSearchGenerateGetSQL(evmSearchGeneratePseudocode(),false));}catch(err){}

	var searchname = evmSplitter(document.getElementById("searchfield-new-name").value," ","");
    if(searchname == "" || searchname == " ")
    {
      alert("Please enter a valid SearchName!");
      return;
    }
    evmInitConnection();
    try
    {
      query = "select id from search where (name ='" + searchname + "')";
      result = connection.executeQuery(query);
    }
    catch(ex)
    {
    }
    try
    {
      if(evmIsEntryAvailableInDB(result))
      {
        if(confirm("Name already exists. Are you sure you want to replace this rule?") == false) return;
        var query = "DELETE FROM search WHERE (name ='" + searchname + "')";
	 	try {var result = connection.executeQuery(query);} catch(err){};
      }
    }
    catch(ex)
    {
    }
	var childof = document.getElementById("evm-search-searchcategory").label;
	var childof = evmSplitter(childof," ","");
    try
    {
      query = "select id, name from search where (name ='" + childof + "')";
      result = connection.executeQuery(query);
    }
    catch(ex)
    {
    }
    try
    {
      if(evmIsEntryAvailableInDB(result))
      {
        var enumerator = result.enumerate();
        enumerator.first();
        childof = enumerator.getVariant(0);
      }
      else childof = 0;
    }
    catch(ex)
    {
      childof = 0;
    }
    try
    {
      var query = "select max(id) from search";
      var result = connection.executeQuery(query);
    }
    catch(ex) { }
    try
    {
      if(!evmIsEntryAvailableInDB(result)) recipid = 0;
      else recipid = evmReturnAvailableDBEntry(result);
      recipid = recipid + 1;
      sql_headerfields = "id, name, childOf, searchstring";
      sql_headervalues = recipid + ",'" + searchname + "'," + childof + ",'" + evmSearchGeneratePseudocode() + "'";
	  try
  	  {
        query = "INSERT INTO search (" + sql_headerfields + ") VALUES (" + sql_headervalues + ")";
        result = connection.executeQuery(query);
      }
      catch (ex)
      {
      }
    }
    catch(ex)
    {
    }
    evmUpdateSearchtrees();
    evmChangePaneTo(1);
  }


  // *************************************************************************
  // function:		evmSearchClearSearchRows()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // clears the search pane (e.g. before editing)
  function evmSearchClearSearchRows()
  {
    document.getElementById("searchfield-new-name").setAttribute('value',"");
    var parentbox = document.getElementById("superbox");
    while(getNumRows() >= 1)
    {
      parentbox.removeChild(parentbox.lastChild);
    }
    checkButtonStates();
    var sql_text = document.getElementById("evm-search-textbox-query");
    sql_text.setAttribute("value","");
  }


  // *************************************************************************
  // function:		evmSearchFieldDropdownEvent()
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // event handler for fieldlist: in case an existing rule is chosen, we do not
  // need dropdowns like 'contains' or whatever
  function evmSearchFieldDropdownEvent()
  {
    for (var i=1; i <= getNumRows(); i++)
    {
      var what = document.getElementById("fieldlist-"+i).value;
      if(what.indexOf("evmRule") == 0)
      {
        document.getElementById("criterialist-"+i).setAttribute('disabled',true);
        document.getElementById("searchtext-"+i).setAttribute('value',"<no value needed>");
      }
      else
      {
        document.getElementById("criterialist-"+i).setAttribute('disabled',false);
        // document.getElementById("searchtext-"+i).setAttribute('value',"");
      }
    }
  }


  // *************************************************************************
  // function:		evmSearchReset()
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // Clears all search fields and creates an ampty one
  function evmSearchReset()
  {
    evmSearchClearSearchRows();
    evmSearchNewSearchRow();
  }


// **************************************************************************
// ******************* END of EVM-SEARCH-XUL Functions **********************
// **************************************************************************
