/*
 * The contents of this file are subject to the Netscape Public License
 * Version 1.0 (the "License"); you may not use this file except in
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation.  All Rights
 * Reserved.
 *
 * Contributor(s):
 *   EVM-Group <evm@s3.uni-essen.de>
 */


// **************************************************************************
// ************************ EVM-XUL Functions *******************************
// **************************************************************************
// +++ EVM window functions +++
// * for English description please read functions' prologues
//
// Andr Grothues:
// function evmChangePaneTo(Panenumber)
// function evmGetParentId(tree,currentindex)
// function evmIsElementInArray(element,searcharray)
// function evmRecordsetToArray(SQLquery)
// function evmDeleteCategoriesFromPopup(menuname)
// function evmCategoriesToPopup(foldertreename,columnname,menuname,messagetreename)
// function evmCreateTreeItem(treename, columnitems, id, parent_id, doinsertcategoryintodb)
// function evmGetMax(tablename,valuename)
// function evmUserCreateCategory(treename, subcategory)
// function evmDeleteCurrent(treename)
// function evmGetAttributeOfSubcategories(treename,parentitem,attribute)
// function evmRenameCurrent(treename,columnname)
// function evmGetCell(treename,columnname,item)
// function evmGetAllSelectedTreeitems(treename,all)
// function evmGetAllColumnsOfItem(treename,item,columncollection)
// function evmInitializeFolderMenu(treename,menuitemid)
// function evmInitializeThreadMenu(treename,menuitemid)
// function evmXWriteFile(name,value)
// function evmXDeleteFile(name,fromchrome)
// function evmGetMozDir()
// function evmGetMailboxpathFromServerURI(ServerURI)
// function evmGetFolderPathFromFolderURI(FolderURI)
// function evmReturnChromePath(name)
// function evmCreateAttachmentFile(messageID,folderURI,mailboxpath)
// function evmGetTimestamp(messageID,folderURI,mailboxpath)
// function evmDeleteMessageFromThreadpane(selectedelements)
// function evmRefreshView(threadtreename, foldertreename)
// function evmMoveTo(event,threadtreename, foldertreename)
// function evmCopyTo(event,threadtreename)
// function evmShowWaitDialogue(width,height,left)
// function evmClearListbox(listboxID)
// function evmWriteHeaderData()
// evmdeletefrom(event, threadtreename, foldertreename)
// evmNewSearch()
// evmEditSearch()
// evmDeleteSearch()
//
//
// **************************************************************************
// Version: 18.02.2004 (Andr Grothues, Kai Henning)
// **************************************************************************


  // *************************************************************************
  // function:		evmChangePaneTo(Panenumber)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // provides switching between mailview and category pane
  function evmChangePaneTo(Panenumber)
  {
    var FirstPaneTop = document.getElementById("evmEVMWindowTabboxMailview");
	var FirstPane = document.getElementById("evmEVMWindowTabpanelMailview");
	var SecondPaneTop = document.getElementById("evmEVMWindowTabboxCategory");
	var SecondPane = document.getElementById("evmEVMWindowTabpanelCategory");
	var FifthPaneTop = document.getElementById("evmEVMWindowTabboxSearch");
	var FifthPane = document.getElementById("evmEVMWindowTabpanelSearch");
	if (Panenumber==1)
	{
  	  FirstPaneTop.setAttribute("selected","true");
	  SecondPaneTop.setAttribute("selected","false");
	  FifthPaneTop.setAttribute("selected","false");
	  document.getElementById("evmEVMWindowTabbox").selectedPanel = FirstPane;
	}
	else if (Panenumber==5)
	{
	  FirstPaneTop.setAttribute("selected","false");
	  SecondPaneTop.setAttribute("selected","false");
	  FifthPaneTop.setAttribute("selected","true");
	  document.getElementById("evmEVMWindowTabbox").selectedPanel = FifthPane;
	}
	else
	{
	  FirstPaneTop.setAttribute("selected","false");
	  SecondPaneTop.setAttribute("selected","true");
	  FifthPaneTop.setAttribute("selected","false");
	  document.getElementById("evmEVMWindowTabbox").selectedPanel = SecondPane;
	}
  }


  // *************************************************************************
  // function:		evmGetParentId(tree,currentindex)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // returns the id of the current element's parent
  function evmGetParentId(tree,currentindex)
  {
    var currentlevel = tree.treeBoxObject.view.getLevel(currentindex);
	var variantlevel = currentlevel;
	if (currentlevel > 0)
	{
  	  while (tree.treeBoxObject.view.getLevel(currentindex)==currentlevel && currentindex >= 0)
	  {
	    currentindex--;
	  }
	  if (tree.treeBoxObject.view.getLevel(currentindex)==currentlevel-1)
	    return tree.treeBoxObject.view.getItemAtIndex(currentindex).getAttribute("id");
	}
  }


  // *************************************************************************
  // function:		evmIsElementInArray(element,searcharray)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // checks whether 'element' is in 'searcharray'
  function evmIsElementInArray(element,searcharray)
  {
 	try
 	{
	  var found = false;
 	  for (var x=0; x < searcharray.length; x++)
 	  {
 	    if (searcharray[x]==element)
 		{
 		  found=true;
 		}
 	  }
	  return found;
	}
	catch(err)
	{}
  }


  // *************************************************************************
  // function:		evmRecordsetToArray(SQLquery)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // writes all DB results into an array
  function evmRecordsetToArray(SQLquery)
  {
   	try {result = connection.executeQuery(SQLquery);} catch(err){}
   	var resultarray=[];
	try
	{
	  if (result.rowCount>0)
	  {
	    var recordset = result.enumerate();
		recordset.first();
		resultarray.push(recordset.getVariant(0));
		for (var x=1; x<result.rowCount; x++)
		{
		  recordset.next();
		  resultarray.push(recordset.getVariant(0));
		}
	  }
	  return resultarray;
	}
	catch(err)
	{
	}
  }


  // *************************************************************************
  // function:		evmDeleteCategoriesFromPopup(tree,menuname)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // deletes items from popup
  function evmDeleteCategoriesFromPopup(menuname)
  {
    var menu = document.getElementById(menuname);
	var menupopup = menu.firstChild;
	while (menupopup.hasChildNodes()==true)
	{
	  menupopup.removeChild(menupopup.firstChild);
	}
  }


  // *************************************************************************
  // function:		evmCategoriesToPopup(treename,columnname,menuname)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // walks through the tree and puts tree columns into the popup
  function evmCategoriesToPopup(foldertreename,columnname,menuname,messagetreename)
  {
    evmDeleteCategoriesFromPopup(menuname);
	var messageIDs = [];
	var folderIDs = [];
	var selectedMessages = evmGetAllSelectedTreeitems(messagetreename,false);
	for (var x=0; x<selectedMessages.length; x++) messageIDs.push (evmGetCell(messagetreename,'evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid',selectedMessages[x]));
	var query = "SELECT categoryid FROM header_category where 5=4";
	for (var x=0; x < messageIDs.length; x++)
	query = query + " OR msgid ='" + messageIDs[x] + "'";
	folderIDs = evmRecordsetToArray(query);
  	var tree = document.getElementById(foldertreename);
	var index = 0
	try
	{
	  while (tree.treeBoxObject.view.getItemAtIndex(index)!=null)
	  {
	    var current = tree.treeBoxObject.view.getItemAtIndex(index);
		if (current.getAttribute("DBid") != "-1232006")
		{
	  	  var parent_tree = current.parentNode;
		  var parentid = evmGetParentId(tree,index);
		  if (parentid==null) parentid = tree.lastChild.getAttribute("id");
		  var parent_menu = document.getElementById(menuname + parentid);
		  var cellcontent = tree.treeBoxObject.view.getCellText(index,columnname);
		  if (current.getAttribute("container","true"))
		  {
		  	var menu = document.createElement("menu");
			menu.setAttribute("label",cellcontent);
			var mpopup = document.createElement("menupopup");
			mpopup.setAttribute("id",menuname + current.getAttribute("id"));
			var mi = document.createElement("menuitem");
			mi.setAttribute("label","<- put here");
            mi.setAttribute("DBid",current.getAttribute("DBid"));
            var tmpid = current.getAttribute("DBid");
            if (tmpid.length > 45) tmpid = current.getAttribute("DBid").substring(45);
			if (evmIsElementInArray(tmpid,folderIDs)==true) mi.setAttribute("disabled","true");
			else mi.setAttribute("disabled","false");
			mpopup.appendChild(mi);
	        var ms = document.createElement("menuseparator");
    	    mpopup.appendChild(ms);
    	    menu.appendChild(mpopup);
			parent_menu.appendChild(menu);
		  }
		  else
		  {
		    var mi = document.createElement("menuitem");
            mi.setAttribute("label",cellcontent);
		  	mi.setAttribute("DBid",current.getAttribute("DBid"));
		  	var tmpid = current.getAttribute("DBid");
            if (tmpid.length > 45) tmpid = current.getAttribute("DBid").substring(45);
            if (evmIsElementInArray(tmpid,folderIDs)==true) mi.setAttribute("disabled","true");
			else mi.setAttribute("disabled","false");
    	    parent_menu.appendChild(mi);
		  }
		}
	  	index++;
	  }
	}
	catch (err)
	{
	}
  }

  // *************************************************************************
  // function:		evmSelectedCategoriesToPopup(menuname,columnname,messagetreename)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // walks through the threadpane, gets all selected messages and displays the foldernames in the delete from popup
  function evmSelectedCategoriesToPopup(menuname,columnname,messagetreename)
  {
  	try
  	{
      var messageIDs = [];
      evmDeleteCategoriesFromPopup(menuname);
      var deletefrommenu = document.getElementById(menuname + "evmEVMWindowMailviewFolderpaneboxCategorytreechildren");

      var mi = document.createElement("menuitem");
      mi.setAttribute("label","database");
      mi.setAttribute("id",menuname+"database");
      mi.setAttribute("DBid","database");
	  deletefrommenu.appendChild(mi);

	  var menuseparator = document.createElement("menuseparator");
	  deletefrommenu.appendChild(menuseparator);

      var mi = document.createElement("menuitem");
      mi.setAttribute("label","all categories");
      mi.setAttribute("id",menuname+"allcategories");
      mi.setAttribute("DBid","all");
	  deletefrommenu.appendChild(mi);

	  var menuseparator = document.createElement("menuseparator");
	  deletefrommenu.appendChild(menuseparator);

	  var selectedMessages = evmGetAllSelectedTreeitems(messagetreename,false);
	  for (var x=0; x<selectedMessages.length; x++) messageIDs.push (evmGetCell(messagetreename,'evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid',selectedMessages[x]));
	  var query = "SELECT category.id, category.name FROM header_category JOIN category ON (category.id=header_category.categoryid) where 5=4";
	  for (var x=0; x < messageIDs.length; x++) query = query + " OR msgid ='" + messageIDs[x] + "'";
	  var result = connection.executeQuery(query + " ORDER BY category.id");
	  if (result.rowCount>0)
	  {
		var enumerator = result.enumerate();
	  	enumerator.first();
	    var lastid="";
	  	for (var x=1; x<=result.rowCount; x++)
  	  	{
 	      if (lastid!=enumerator.getVariant(0))
 	      {
 	        var mi = document.createElement("menuitem");
            mi.setAttribute("label",enumerator.getVariant(1));
	        mi.setAttribute("DBid",enumerator.getVariant(0));
	        deletefrommenu.appendChild(mi);
	        lastid = enumerator.getVariant(0);
	      }
	      if (x < result.rowCount) enumerator.next();
	  	}
	  }
	  else
	  {
	  	document.getElementById(menuname+"allcategories").setAttribute("disabled","true");
	  }
	}
	catch(err)
	{
	}
  }

  // *************************************************************************
  // function:		evmCreateTreeItem(treename, columnitems, id, parent_id, doinsertcategoryintodb)
  // status:		finished
  // author:		Andr Grothues, Kai Henning
  // *************************************************************************
  // THE main function to create a treeitem to a tree: either topcategories,
  // first children, or more children
  // for that, we have to specify the name of the tree, the items we want to
  // insert, the parent id, and if the user creates a new category we also want
  // to save this new one in the DB (so we have to pass a boolean parameter
  // whether we also want to insert the item to the DB or not)
  function evmCreateTreeItem(treename, columnitems, id, parent_id, doinsertcategoryintodb)
  {
  	try
  	{
        // The structure of a tree is:
        //  <tree>
        //      <treechildren>
        //          <treeitem>
        //              <treerow>
        //                  <treecell/>
        //              </treerow>
        //              <treechildren>
        //                  ...
        //              </treechildren>
        //          </treeitem>
        //      </treechildren>
        //  </tree>
        var tree = document.getElementById(treename);
        var parentitem = document.getElementById(parent_id);
        var parentindex = tree.treeBoxObject.view.getIndexOfItem(parentitem);

        if (parentitem != null)
        {
          // create Treerow with "row" + id
          var tr = document.createElement("treerow");
          tr.setAttribute("id", treename + "row" + id);

          for (x=0; x<columnitems.length; x++)
          {
            var tc = document.createElement("treecell");
            tc.setAttribute("label", columnitems[x]);
            if(x==0) firstcolumnname = columnitems[x];
            tc.setAttribute("id",treename + id + "-column" + (x + 1));
            tr.appendChild(tc);
          }

          // create treeitem with "item" + id
          var ti = document.createElement("treeitem");
          ti.setAttribute("id", treename + id);
          ti.setAttribute("DBid", id);
          ti.appendChild(tr);

          // we distinguish the case that
          //        the container of the item is empty --> create new treechildren object and append item
          //        a treechildren-object already exists --> get the id and append new item to this one
          //        the new element is under the root of the tree --> put parentitem directly under the root

          // first Child
          if (parentitem.getAttribute("container") != "true" && parentitem.getAttribute("open") != "true" && parentindex >= 0)
          {
            parentitem.setAttribute("container", "true");
            var tch = document.createElement("treechildren");
            tch.setAttribute("id", "treechildren" + id);
            tch.appendChild(ti);
            parentitem.appendChild(tch);
            if(parentitem.hasAttribute("DBid") == true)
            {
              wurst = parentitem.getAttribute("DBid");
              try
              {
                w = parseInt(wurst);
                if(evmIsInteger(w)) pid = w;
                else
                {
                  honk = wurst.split("ategorytree");
                  pid = honk[1];
                }
              }
              catch(ex)
              {
                honk = wurst.split("ategorytree");
                pid = honk[1];
              }
            }
            if(treename.indexOf("ategorytree") >= 0 && doinsertcategoryintodb == true)
            {
              sql_headerfields = "id, name, childof";
              sql_headervalues = id + ",'" + firstcolumnname + "'," + pid;
              try
              {
                query = "INSERT INTO category (" + sql_headerfields + ") VALUES (" + sql_headervalues + ")";
                result = connection.executeQuery(query);
              }
              catch (ex)
              {
              }
            }
          }
          // Second, Third (or more) Child
          else if ((parentitem.getAttribute("container") != "false" && parentindex >= 0) || (parentitem.getAttribute("container") == "false" && parentitem.getAttribute("open") == "true"))
          {
            var existingtreechildren = document.getElementById(parentitem.childNodes.item(1).getAttribute("id"));
            existingtreechildren.appendChild(ti);
            if(parentitem.hasAttribute("DBid") == true)
            {
              wurst = parentitem.getAttribute("DBid");
              try
              {
                w = parseInt(wurst);
                if(evmIsInteger(w)) pid = w;
                else
                {
                  honk = wurst.split("ategorytree");
                  pid = honk[1];
                }
              }
              catch(ex)
              {
                honk = wurst.split("ategorytree");
                pid = honk[1];
              }
            }
            if(treename.indexOf("ategorytree") >= 0 && doinsertcategoryintodb == true)
            {
              sql_headerfields = "id, name, childof";
              sql_headervalues = id + ",'" + firstcolumnname + "'," + pid;
              try
              {
                query = "INSERT INTO category (" + sql_headerfields + ") VALUES (" + sql_headervalues + ")";
                result = connection.executeQuery(query);
              }
              catch (ex)
              {
              }
            }
          }
          // new Topcategory
          else
          {
            if(treename.indexOf("ategorytree") >= 0 && doinsertcategoryintodb == true)
            {
              sql_headerfields = "id, name, childof";
              sql_headervalues = id + ",'" + firstcolumnname + "'," + 0;
              try
              {
                query = "INSERT INTO category (" + sql_headerfields + ") VALUES (" + sql_headervalues + ")";
                result = connection.executeQuery(query);
              }
              catch (ex)
              {
              }
            }
            parentitem.appendChild(ti);
          }
          // set open status of the item
          parentitem.setAttribute("open", "true");
        }
	}
	catch(err)
	{
		alert(err);
	}
  }


  // *************************************************************************
  // function:		evmGetMax(tablename,valuename)
  // status:		finished
  // author:		Andr Grothues, Kai Henning
  // *************************************************************************
  // gets the next free id for a new category
  function evmGetMax(tablename,valuename)
  {
    try
  	{
      var query = "select max(id) from category";
      var result = connection.executeQuery(query);
    }
    catch(ex) { }
    try
    {
      if(!evmIsEntryAvailableInDB(result)) tempid = 0;
        else tempid = evmReturnAvailableDBEntry(result);
      tempid = tempid + 1;
    }
    catch(ex)
    {
    }
	return tempid;
  }


  // *************************************************************************
  // function:		evmUserCreateCategory(treename, subcategory)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // provides the 'user interface' for creating a new category
  function evmUserCreateCategory(treename, subcategory)
  {
    columnitems = prompt('Please enter a categoryname','undefined')
	if (columnitems != "" && columnitems != null)
	{
	  var tree = document.getElementById(treename);
	  id = evmGetMax("category","id");
	  if (subcategory==true)
	     parent_id = tree.treeBoxObject.view.getItemAtIndex(tree.currentIndex).getAttribute("id");
	  else
	     parent_id = treename + "children";
	  evmCreateTreeItem(treename, [columnitems], id, parent_id, true);
	}
	evmUpdateCategorytrees();
  }


  // *************************************************************************
  // function:		evmDeleteCurrent(treename)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // provides the 'user interface' for deleting an existing category
  function evmDeleteCurrent(treename)
  {
	try
	{
	  if (confirm("Are you sure you want to delete this category?")==true)
	  {
	    var tree = document.getElementById(treename);
		var selectedelements = evmGetAllSelectedTreeitems(treename,false);
		for (var x=0; x<selectedelements.length; x++)
		{
		  var currentelement = selectedelements[x];
		  var parentelement = currentelement.parentNode;
		  var DBids = evmGetAttributeOfSubcategories(treename,selectedelements[x],"DBid");
		  if (DBids!=null)
		  {
		    for (var y = 0; y<DBids.length; y++)
			{
			  var ExtractedID = DBids[y].substring(45);
			  query1 = "UPDATE header_category SET categoryid='-7011980' WHERE (categoryid=" + ExtractedID + ")";
			  query2 = "DELETE FROM category WHERE (id='" + ExtractedID + "')";
			  try {var result = connection.executeQuery(query1);} catch(err){};
			  try {var result = connection.executeQuery(query2);} catch(err){};
			}
		  }
		}
	  }
	}
	catch(err)
	{
	}
	evmInitializeEVM();
  }


  // *************************************************************************
  // function:		evmGetAttributeOfSubcategories(treename,parentitem,attribute)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // returns the selected attribute of the subcategories under the parent item
  function evmGetAttributeOfSubcategories(treename,parentitem,attribute)
  {
  	try
  	{
	  var tree = document.getElementById(treename);
  	  var index = tree.treeBoxObject.view.getIndexOfItem(parentitem);
	  var level = tree.treeBoxObject.view.getLevel(index);
  	  var returncategories = [];
  	  returncategories.push(tree.treeBoxObject.view.getItemAtIndex(index).getAttribute(attribute));
	  index++;
  	  while (tree.treeBoxObject.view.getItemAtIndex(index)!=null && tree.treeBoxObject.view.getLevel(index)>level)
	  {
	    returncategories.push(tree.treeBoxObject.view.getItemAtIndex(index).getAttribute(attribute));
  		index++;
	  }
	}
	catch(err)
	{
	}
  	return returncategories;
  }


  // *************************************************************************
  // function:		evmRenameCurrent(treename,columnname)
  // status:		finished
  // author:		Andr Grothues, Kai Henning
  // *************************************************************************
  // provides a 'user interface' to rename an existing category and saves the
  // changes in the DB
  function evmRenameCurrent(treename,columnname)
  {
    var tree = document.getElementById(treename);
	var currentitem = tree.treeBoxObject.view.getItemAtIndex(tree.currentIndex);
	var currentlabel = tree.treeBoxObject.view.getCellText(tree.currentIndex,columnname);
	var newlabel = prompt("Please enter the new categoryname for "+currentlabel,currentlabel);

	if (newlabel != "" && newlabel != null)
	{
	  var currentcell = document.getElementById(currentitem.getAttribute("id") + "-column1");
	  currentcell.setAttribute("label",newlabel);
      var wurst = currentitem.getAttribute("DBid").split("Categorytree");
      var honk = parseInt(wurst[1]);
      try
      {
        query = "UPDATE category SET name='" + newlabel + "' WHERE (id=" + honk + ")";
        var result = connection.executeQuery(query);
      }
   	  catch(ex)
      {
  	  }
    }
  }


  // *************************************************************************
  // function:		evmGetCell(treename,columnname)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // alerts the columname of the current item chosen in a tree
  function evmGetCell(treename,columnname,item)
  {
    var tree = document.getElementById(treename);
    var index = tree.treeBoxObject.view.getIndexOfItem(item);
    var cellcontent = tree.treeBoxObject.view.getCellText(index,columnname);
    return cellcontent;
  }


  // *************************************************************************
  // function:		evmGetAllSelectedTreeitems(treename)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // returns all treeitems which are chosen in a tree
  function evmGetAllSelectedTreeitems(treename,all)
  {
    var index = 0;
	var itemarray = new Array(0);
	var tree = document.getElementById(treename);
  	try
	{
	  while (tree.treeBoxObject.view.getItemAtIndex(index)!=null)
	  {
	    if (tree.treeBoxObject.selection.isSelected(index)==true || all==true)
		   itemarray.push(tree.treeBoxObject.view.getItemAtIndex(index));
		index++;
	  }
	}
	catch (e)
  	{
	}
	return itemarray;
  }


  // *************************************************************************
  // function:		evmInitializeFolderMenu(treename)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // initializes the folder-pane popup-menu
  function evmInitializeFolderMenu(treename,menuitemid)
  {
	var tree = document.getElementById(treename);
	var newsubcategory = document.getElementById(menuitemid + "Subcategory");
	var renamecategory = document.getElementById(menuitemid + "Rename");
	var deletecategory = document.getElementById(menuitemid + "Delete");

	if (tree.treeBoxObject.selection.count == 0)
	{
	  newsubcategory.setAttribute("disabled","true");
  	  renamecategory.setAttribute("disabled","true");
  	  deletecategory.setAttribute("disabled","true");
	}
	else
	{
	  newsubcategory.setAttribute("disabled","false");
   	  renamecategory.setAttribute("disabled","false");
  	  deletecategory.setAttribute("disabled","false");
	  var selecteditems = evmGetAllSelectedTreeitems(treename,false);
	  for (var x=0; x<selecteditems.length; x++)
	  {
	  	if (selecteditems[x].getAttribute("DBid")=="-7011980" || selecteditems[x].getAttribute("DBid")=="-1232006")
	  	{
	  	  	newsubcategory.setAttribute("disabled","true");
  	  		renamecategory.setAttribute("disabled","true");
		  	deletecategory.setAttribute("disabled","true");
			if(selecteditems[x].getAttribute("DBid")=="-7011980" && evmStuffInTrash())
			  document.getElementById("evmEVMWindowTabpanelMailviewFolderPopupsetMenuitemEmptyTrash").setAttribute("disabled","false");
			else
			  document.getElementById("evmEVMWindowTabpanelMailviewFolderPopupsetMenuitemEmptyTrash").setAttribute("disabled","true");
	  	}
		else document.getElementById("evmEVMWindowTabpanelMailviewFolderPopupsetMenuitemEmptyTrash").setAttribute("disabled","true");
	  }
	}
	if (tree.treeBoxObject.selection.count > 1)
	{
	  newsubcategory.setAttribute("disabled","true");
	  renamecategory.setAttribute("disabled","true");
	}

  }


  // *************************************************************************
  // function:		evmInitializeThreadMenu(treename)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // initializes the thread-pane popup-menu
  function evmInitializeThreadMenu(treename,menuitemid)
  {
	var tree = document.getElementById(treename);
	var open = document.getElementById(menuitemid + "OpenMessage");
	var reply = document.getElementById(menuitemid + "Reply");
	var replyall = document.getElementById(menuitemid + "ReplyAll");
	var forward = document.getElementById(menuitemid + "Forward");
	var copyto = document.getElementById("copytomenu");
	var moveto = document.getElementById("movetomenu");
	var deleteentry = document.getElementById(menuitemid + "Delete");
	var deletefromentry = document.getElementById("deletefrommenu");
	if (tree.treeBoxObject.selection.count == 0)
	{
	  open.setAttribute("disabled","true");
	  reply.setAttribute("disabled","true");
  	  replyall.setAttribute("disabled","true");
  	  forward.setAttribute("disabled","true");
  	  copyto.setAttribute("disabled","true");
  	  moveto.setAttribute("disabled","true");
	  deleteentry.setAttribute("disabled","true");
	  deletefromentry.setAttribute("disabled","true");
	}
	else
	{
	  open.setAttribute("disabled","false");
	  reply.setAttribute("disabled","false");
   	  replyall.setAttribute("disabled","false");
  	  forward.setAttribute("disabled","false");
  	  copyto.setAttribute("disabled","false");
  	  if (selected==2)
  	  {
  	    moveto.setAttribute("disabled","true");
	    deleteentry.setAttribute("disabled","true");
	  }
  	  else
  	  {
  	    moveto.setAttribute("disabled","false");
	    deleteentry.setAttribute("disabled","false");
	  }
	  deletefromentry.setAttribute("disabled","false");
	}
  }



  // *************************************************************************
  // function:		evmXWriteFile(name,value)
  // status:		finished
  // author:		Andr Grothues, Kai Henning
  // *************************************************************************
  // writes a value into a file (called <name>), normally used for temporary
  // body files in the chrome directory
  function evmXWriteFile(name,value)
  {
    try
	{
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	  include(jslib_io);
	  include(jslib_fileutils);
	  pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	  var f = new FileUtils();
	  var x = f.chrome_to_path(name);
	  var translatedpath = evmSplitter(x,"/",evmPathSep());

	  var file = new File(translatedpath);

	  if (file.exists() == true)
	  {
	    file.remove(translatedpath);
	  }

	  file = new File(translatedpath);
	  if (file.exists() == false)
	  {
	    file.create();
	  	file.open("w");
	    file.write(value);
	    return file.size;
	  }
	}
  	catch(err)
	{
	  alert("EVM Writing Error: " + err);
	}
  }


  // *************************************************************************
  // function:		evmXDeleteFile(name)
  // status:		finished
  // author:		Andr Grothues, Kai Henning
  // *************************************************************************
  // deletes a file in the chrome directory
  function evmXDeleteFile(name,fromchrome)
  {
    try
	{
	  pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	  include(jslib_io);
	  include(jslib_fileutils);

	  if(fromchrome == true)
	  {
	    var f = new FileUtils();
		var x = f.chrome_to_path(name);
		var translatedpath = evmSplitter(x,"/",evmPathSep());
		var file = new File(translatedpath);
	  }
	  else var file = new File(name);

	  if (file.exists() == true)
	  {
	    file.remove(translatedpath);
	  }
	}
	catch(err)
	{
	  alert("EVM Deleting Error: " + err);
	}
  }


  // *************************************************************************
  // function:		evmGetMailboxpathFromServerURI(ServerURI)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // returns the path of the mailbox
  function evmGetMailboxpathFromServerURI(ServerURI)
  {
  	var mailboxname = ServerURI.split("@");
  	var realmailboxname = evmSplitter(mailboxname[1],"%20"," ");
    var accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var allServers = accountManager.allServers;
    var numServers = allServers.Count();
    var serverBehandelt = 1;
    for(var j = 1; serverBehandelt <= numServers; j++)
    {
      var aktuell = "mail.server.server" + j + ".hostname";
      try
      {
        if(pref.getCharPref(aktuell).indexOf(realmailboxname) >= 0)
        {
          return pref.getCharPref("mail.server.server" + j + ".directory");
        }
        serverBehandelt++;
      }
      catch(ex)
      {
      }
    }
    return "evmError";
  }


  // *************************************************************************
  // function:		evmGetFolderPathFromFolderURI(FolderURI)
  // status:		finished
  // author:		Kai Henning
  // *************************************************************************
  // returns the folder-in-folder directories of a server
  function evmGetFolderPathFromFolderURI(FolderURI)
  {
	pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var rightpart = FolderURI.split("@");
	var folderparts = rightpart[1].split("/");
	var folderpath = "";
	for(var j = 1; j < folderparts.length; j++)
	{
	  folderpath = folderpath + evmPathSep() + folderparts[j];
	  if(j < folderparts.length-1) folderpath = folderpath + ".sbd";
	}
	return folderpath;
  }


  // *************************************************************************
  // function:		evmReturnChromePath(name)
  // status:		finished
  // author:		Kai Henning / Andr Grothues
  // *************************************************************************
  // returns the chrome path
  function evmReturnChromePath(name)
  {
	pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	include(jslib_fileutils);
	var f = new FileUtils();
	var x = f.chrome_to_path("chrome://evm/content/" + name);
	var translatedpath = evmSplitter(x,"/",evmPathSep());
	return translatedpath;
  }


  // *************************************************************************
  // function:		evmCreateAttachmentFile(messageID,folderURI,mailboxpath)
  // status:		finished
  // author:		Andr Grothues, Kai Henning
  // *************************************************************************
  // if we have a mail with at least one attachment, we save the whole message
  // in a file <messageID>.evm in the chrome directory, so that we can use
  // Mozilla's own compose windows etc for displaying etc
  function evmCreateAttachmentFile(messageID,folderURI,mailboxpath)
  {
	try
	{
	  pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	  include (jslib_io);
	  include(jslib_fileutils);
	  var du = new DirUtils();

	  if(mailboxpath == "evmError")
	  {
	    var path = du.getUserMailDir();
		var f = folderURI.split('@');
		var fURI = f[1];
		var path = path + evmPathSep() + evmSplitter(evmSplitter(fURI,"/",evmPathSep()),"%20"," ");
	  }
	  else path = mailboxpath + folderURI;

	  var file = new File(path);
	  if (file.exists() == false) alert(path);
	  file.open("r");

	  var whatwewant = "Message-ID: <" + messageID + ">";
	  whatwewant = whatwewant.toUpperCase();

	  var linearray = [];
	  var linearrayblank = 0;

	  var timestamp_found = false;
	  var timestamp = "evmTimestampError";

	  while(!file.EOF)
	  {
        var ContentsLine = file.readline();
        var TempContentsLine = ContentsLine.toUpperCase();
		if(TempContentsLine.indexOf("DATE: ") == 0) timestamp = ContentsLine;

        if (TempContentsLine.indexOf(whatwewant) != 0)
        {
		  if(ContentsLine != "")
          {
            linearray.push (ContentsLine);
            linearrayblank = 0;
          }
          else
          {
            linearrayblank++;
          }
          if(linearrayblank == 2)
          {
            linearrayblank = 0;
            linearray = [];
          }
        }
        else
        {
          var du = new DirUtils();
		  //var path = evmReturnChromePath("evmMail_" + messageID + ".evm");
		  var path = evmGetAttachmentMailDir() + "evmMail_" + messageID + ".evm";
		  var targetfile = new File(path);
		  if (targetfile.exists()==true) targetfile.remove();
		  targetfile.create();
		  targetfile.open("w");
          for(var i = 0; i < linearray.length; i++)
          {
            if (linearray[i].indexOf("X-Mozilla-Status: ") != 0) targetfile.write(linearray[i] + "\n");
            else targetfile.write("X-Mozilla-Status: 0001" + "\n");
          }
          //targetfile.write(ContentsLine + "\n");
		  var blank = false;

		  whatwewant = "X-Mozilla-Status: "; // Anfang der nchsten Mail
		  whatwewant = whatwewant.toUpperCase();

		  while (TempContentsLine.indexOf(whatwewant) != 0 && file.EOF!=true)
		  {
		    if((timestamp_found == false) && (TempContentsLine.indexOf("DATE: ") == 0)) timestamp = ContentsLine;
			if (ContentsLine != "")
			{
			  blank = false;
			  targetfile.write(ContentsLine + "\n");
  	    	}
  	    	else
  	    	{
  	    	  if(blank == true)
  	    	  {
  	    	    targetfile.write("\n");
  	    		blank = false;
  	    		timestamp_found = true;
  	    	  }
  	    	  else blank = true;
  	    	}
			ContentsLine = file.readline();
			TempContentsLine = ContentsLine.toUpperCase();
		  }
		  var tst = timestamp.split("ate: ");
		  return tst[1];
		}
	  }
	}
	catch (err)
	{
	  alert("EVM CreateAttachmentFile Error: " + err);
	}
  }


  // *************************************************************************
  // function:		evmGetTimestamp(messageID,folderURI,mailboxpath)
  // status:		finished
  // author:		Andr Grothues, Kai Henning
  // *************************************************************************
  // same functionality as evmCreateAttachmentFile(messageID,folderURI,mailboxpath),
  // but for mails w/o attachment -> as we need the timestamp, we simply make a walk-
  // through and that's it... ;-)
  function evmGetTimestamp(messageID,folderURI,mailboxpath)
  {
	try
	{
	  pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	  include (jslib_io);
	  include(jslib_fileutils);
	  var du = new DirUtils();
	  if(mailboxpath == "evmError")
	  {
		var path = du.getUserMailDir();
		var f = folderURI.split('@');
		var fURI = f[1];
		var path = path + evmPathSep() + evmSplitter(evmSplitter(fURI,"/",evmPathSep()),"%20"," ");
	  }
	  else path = mailboxpath + folderURI;
	  var file = new File(path);
	  if (file.exists() == false) alert(path);
	  file.open("r");
	  var whatwewant = "Message-ID: <" + messageID + ">";
	  whatwewant = whatwewant.toUpperCase();
	  var timestamp_found = false;
	  var timestamp = "evmTimestampError";
	  while(!file.EOF)
	  {
        var ContentsLine = file.readline();
        var TempContentsLine = ContentsLine.toUpperCase();
		if(TempContentsLine.indexOf("DATE: ") == 0) timestamp = ContentsLine;
		if (TempContentsLine.indexOf(whatwewant) < 0)
        {
        }
        else
        {
		  var blank = false;
		  whatwewant = "X-Mozilla-Status: 0001"; // Anfang der nchsten Mail
		  whatwewant = whatwewant.toUpperCase();
		  while (TempContentsLine.indexOf(whatwewant) < 0 && file.EOF!=true && timestamp_found == false)
		  {
		    if((timestamp_found == false) && (TempContentsLine.indexOf("DATE: ") == 0)) timestamp = ContentsLine;
			if (ContentsLine != "")
			{
			  blank = false;
  	    	}
  	    	else
  	    	{
  	    	  if(blank == true)
  	    	  {
  	    	    blank = false;
  	    		timestamp_found = true;
  	    	  }
  	    	  else blank = true;
   			}
			ContentsLine = file.readline();
			TempContentsLine = ContentsLine.toUpperCase();
		  }
		  var tst = timestamp.split("ate: ");
		  return tst[1];
		}
	  }
	}
	catch (err)
	{
	  alert("EVM GetTimestamp Error: " + err);
	}
  }


  // *************************************************************************
  // function:		evmRefreshView(threadtreename, foldertreename)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // calls event handler to refresh view
  function evmRefreshView(threadtreename, foldertreename)
  {
    evmMailviewfolderpaneboxselected(globalorderbycolumn, globalordertype);
  }


  // *************************************************************************
  // function:		evmMoveTo(event)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // realizes the move-to event
  function evmMoveTo(event,threadtreename, foldertreename)
  {
  	var categorytree = document.getElementById(foldertreename);
	var categoryindex = categorytree.treeBoxObject.selection.currentIndex;
  	try
  	{
  	  var contextmenu = document.getElementById('evmEVMWindowTabpanelMailviewThreadPopupset');
  	  contextmenu.hidePopup();
	  var newDBid = event.target.getAttribute("DBid");
  	  if (newDBid.length > 45) var newDBid=newDBid.substring(45);
  	  var selectedcategoryDBid = evmGetAllSelectedTreeitems(foldertreename,false)[0].getAttribute("DBid");
 	  if (selectedcategoryDBid.length > 45) var selectedcategoryDBid=selectedcategoryDBid.substring(45);
	  var selectedelements = evmGetAllSelectedTreeitems(threadtreename,false);
	  for (var x=0; x<selectedelements.length; x++)
	  {
	    var currentelement = selectedelements[x];
	    var parentelement = currentelement.parentNode;
	 	var Mid = evmGetCell(threadtreename,'evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid',currentelement);
	 	var testquery = "Select * FROM header_category WHERE msgid='" + Mid + "' AND categoryid='" + newDBid +"'";
	 	try {var tmpresult = connection.executeQuery(testquery);} catch(err){};
	 	if (tmpresult.rowCount > 0)
	 		query = "DELETE FROM header_category WHERE msgid='" + Mid + "' AND categoryid='" + selectedcategoryDBid +"'";
	 	else
	 	 	query = "UPDATE header_category SET categoryid='" + newDBid + "' WHERE (categoryid='" + selectedcategoryDBid + "' AND msgid='" + Mid + "')";
	 	try {var result = connection.executeQuery(query);} catch(err){};
	  }
	}
	catch(err)
	{
	}
	evmRefreshView(threadtreename, foldertreename)
	evmInitializeEVM();
	categorytree.view.selection.select(categoryindex);
  }


 // *************************************************************************
  // function:		evmCopyTo(event)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // realizes the copy-to event
  function evmCopyTo(event,threadtreename)
  {
 	var categorytree = document.getElementById("evmEVMWindowMailviewFolderpaneboxCategorytree");
	var categoryindex = categorytree.treeBoxObject.selection.currentIndex;
  	try
  	{
  	  var contextmenu = document.getElementById('evmEVMWindowTabpanelMailviewThreadPopupset');
  	  contextmenu.hidePopup();
	  var newDBid = event.target.getAttribute("DBid");
	  if (newDBid.length > 45) var newDBid=newDBid.substring(45);
  	  var selectedelements = evmGetAllSelectedTreeitems(threadtreename,false);
	  for (var x=0; x<selectedelements.length; x++)
	  {
	    var currentelement = selectedelements[x];
		var parentelement = currentelement.parentNode;
	 	var Mid = evmGetCell(threadtreename,'evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid',currentelement);
	 	var testquery = "Select * FROM header_category WHERE msgid='" + Mid + "' AND categoryid='" + newDBid +"'";
	 	try {var tmpresult = connection.executeQuery(testquery);} catch(err){};
	 	if (tmpresult.rowCount == 0)
	 	{
		  query = "INSERT INTO header_category (msgid,categoryid) values ('"+ Mid +"', '"+ newDBid + "')";
		  try {var result = connection.executeQuery(query);} catch(err){};
		}
	  }
	}
	catch(err)
	{
	}
	evmRefreshView(threadtreename, "evmEVMWindowMailviewFolderpaneboxCategorytree")
	evmInitializeEVM();
	categorytree.view.selection.select(categoryindex);
  }


  // *************************************************************************
  // function:		evmShowWaitDialogue(width,height,left)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // shows the wait dialogue
  function evmShowWaitDialogue(width,height,left)
  {
	pleaseWait = window.open('', 'PleaseWait', 'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width='+ width +', height='+ height +', left='+ left +', top=200');
    pleaseWait.focus;
    return pleaseWait;
  }


  // *************************************************************************
  // function:		evmClearListbox(listboxID)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // clears all items of a listbox identified by the listboxID
  function evmClearListbox(listboxID)
  {
 	try
	{
   	  var listbox = document.getElementById(listboxID);
   	  var lines = listbox.getRowCount();
   	  for (var x=0; x<lines; x++)
	  {
	    listbox.removeChild(listbox.removeItemAt(0));
	  }
    }
	catch(err)
	{
	}
  }


  // *************************************************************************
  // function:		evmWriteHeaderData()
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // writes basic header elements into top of messagepane
  function evmWriteHeaderData()
  {
	try
	{
	  evmClearListbox("evmEVMWindowMailviewMessagepaneListbox")
	  var tree = document.getElementById("evmEVMWindowMailviewThreadpaneMailtree");
	  var midrow = document.getElementById("evmEVMWindowMailviewMessagepaneMessageID");
	  var senderrow = document.getElementById("evmEVMWindowMailviewMessagepaneSender");
	  var subjectrow = document.getElementById("evmEVMWindowMailviewMessagepaneSubject");
	  var daterow = document.getElementById("evmEVMWindowMailviewMessagepaneDate");
	  var timerow = document.getElementById("evmEVMWindowMailviewMessagepaneTime");
	  if (tree.treeBoxObject.selection.count == 0 || tree.treeBoxObject.selection.count > 1)
	  {
	    midrow.setAttribute("value", "");
	  	senderrow.setAttribute("value", "");
	  	subjectrow.setAttribute("value", "");
	  	daterow.setAttribute("value", "");
	  }
	  else
	  {
	    var listbox = document.getElementById("evmEVMWindowMailviewMessagepaneListbox");
		var msgID = tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid");
	  	midrow.setAttribute("value", "Message ID    : " +  msgID);
	  	senderrow.setAttribute("value", "Sender name  : " + tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSender"));
	  	subjectrow.setAttribute("value", "Subject           : " + tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColSubject"));
	  	daterow.setAttribute("value", "Date               : " + tree.treeBoxObject.view.getCellText(tree.currentIndex,"evmEVMWindowMailviewThreadpaneMailtreeTreeColDatetime"));
	  	var query = "Select name from attachment where msgid='" + msgID + "'";
	  	var result = evmRecordsetToArray(query);
	  	for (var x=0; x<result.length; x++)
	  	{
		  var listitem = document.createElement("listitem");
      	  var listcell = document.createElement("listcell");
      	  listcell.setAttribute("label", result[x]);
          listitem.appendChild(listcell);
      	  listbox.appendChild(listitem);
	  	}
	  }
	}
	catch(err)
	{
	}
  }


  // *************************************************************************
  // function:		evmdeletefrom(event, threadtreename, foldertreename)
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // this function is an event handler of the threadpane popup menu
  // it deletes the selected mail(s) from the specified category
  function evmdeletefrom(event, threadtreename, foldertreename)
  {
  	try
  	{
      var contextmenu = document.getElementById('evmEVMWindowTabpanelMailviewThreadPopupset');
  	  contextmenu.hidePopup();
	  var categorytree;
	  var categoryindex;
  	  if (selected==1)
  	  {
	  	categorytree = document.getElementById(foldertreename);
		categoryindex = categorytree.treeBoxObject.selection.currentIndex;
	  }
	  else
	  {
	  	categorytree = document.getElementById("evmEVMWindowMailviewFolderpaneboxSearchtree");
	    categoryindex = categorytree.treeBoxObject.selection.currentIndex;
	  }
  	  var deletefromid = event.target.getAttribute("DBid");
  	  var selectedelements = evmGetAllSelectedTreeitems(threadtreename,false);
  	  var result = true;
  	  if (deletefromid=="database") result = confirm("Do you really want to PERMANENTLY delete this message?");
  	  if (result==true)
  	  {
  	      for (var x=0; x<selectedelements.length; x++)
          {
            var currentelement = selectedelements[x];
            var Mid = evmGetCell(threadtreename,'evmEVMWindowMailviewThreadpaneMailtreeTreeColMailid',currentelement);
            var testquery = "Select * FROM header_category WHERE msgid='" + Mid + "' AND categoryid='-7011980'";
            try {var tmpresult = connection.executeQuery(testquery);} catch(err){};
            if (tmpresult.rowCount > 0)
            {
              switch (deletefromid)
              {
                case "all":
                {
                  query = "DELETE FROM header_category WHERE msgid='" + Mid + "'";
                  try {var result = connection.executeQuery(query);} catch(err){};
                  query = "INSERT INTO header_category (msgid,categoryid) values ('" + Mid + "','-7011980')";
                  break;
                }
                case "database":
                {
                  try { connection.executeQuery("DELETE FROM header_category WHERE (msgid ='" + Mid + "')"); } catch(ex) {}
                  try { connection.executeQuery("DELETE FROM attachment WHERE (msgid ='" + Mid + "')"); } catch(ex) {}
                  try { connection.executeQuery("DELETE FROM body WHERE (msgid ='" + Mid + "')"); } catch(ex) {}
                  try { connection.executeQuery("DELETE FROM header WHERE (msgid ='" + Mid + "')"); } catch(ex) {}
                  try { connection.executeQuery("DELETE FROM header_mailaddress WHERE (msgid ='" +Mid + "')"); } catch(ex) {}
                  evmXDeleteFile(evmGetAttachmentMailDir() + "evmMail_" + Mid + ".evm",false);

                  break;
                }
                default:
                {
                  query = "DELETE FROM header_category WHERE msgid='" + Mid + "' AND categoryid='" + deletefromid +"'";
                  break;
                }
              }
            }
            else
            {
              switch (deletefromid)
              {
                case "all":
                {
                  query = "DELETE FROM header_category WHERE msgid='" + Mid + "'";
                  try {var result = connection.executeQuery(query);} catch(err){};
                  query = "INSERT INTO header_category (msgid,categoryid) values ('" + Mid + "','-7011980')";
                  break;
                }
                case "database":
                {
                  try { connection.executeQuery("DELETE FROM header_category WHERE (msgid ='" + Mid + "')"); } catch(ex) {}
                  try { connection.executeQuery("DELETE FROM attachment WHERE (msgid ='" + Mid + "')"); } catch(ex) {}
                  try { connection.executeQuery("DELETE FROM body WHERE (msgid ='" + Mid + "')"); } catch(ex) {}
                  try { connection.executeQuery("DELETE FROM header WHERE (msgid ='" + Mid + "')"); } catch(ex) {}
                  try { connection.executeQuery("DELETE FROM header_mailaddress WHERE (msgid ='" +Mid + "')"); } catch(ex) {}
                  evmXDeleteFile(evmGetAttachmentMailDir() + "evmMail_" + Mid + ".evm",false);

                  break;
                }
				default:
                {
                  query = "UPDATE header_category SET categoryid='-7011980' WHERE categoryid='" + deletefromid + "' AND msgid='" + Mid + "'";
                  break;
                }
              }
            }
            try {connection.executeQuery(query);} catch(err){};
          }
      }
	}
	catch(err)
	{
	}
	evmRefreshView(threadtreename, foldertreename);
	evmInitializeEVM();
	categorytree.view.selection.select(categoryindex);
  }


  // *************************************************************************
  // function:		evmNewSearch()
  // status:		busy
  // author:		Andr Grothues
  // *************************************************************************
  //
function evmNewSearch()
{
	evmSearchClearSearchRows();
	evmSearchNewSearchRow();
	evmChangePaneTo(5);
//	evmRefreshView(threadtreename, foldertreename);
	evmInitializeEVM();
//	categorytree.view.selection.select(categoryindex);
}


  // *************************************************************************
  // function:		evmEditSearch()
  // status:		busy
  // author:		Andr Grothues, Kai Henning
  // *************************************************************************
  //
function evmEditSearch()
{
	evmSearchClearSearchRows();
	var pseudocode = " ";
	var searchtree = document.getElementById("evmEVMWindowMailviewFolderpaneboxSearchtree");
	var selectedSearch = evmGetAllSelectedTreeitems("evmEVMWindowMailviewFolderpaneboxSearchtree",false);
	var currentindex = searchtree.treeBoxObject.view.getIndexOfItem(selectedSearch[0]);
	var dbid = searchtree.treeBoxObject.view.getItemAtIndex(currentindex).getAttribute("DBid");
    var query = "SELECT searchstring, name FROM search WHERE (id = " + dbid + ")";
    try
    {
      var result = connection.executeQuery(query);
    }
    catch(ex) { }
    try
    {
      if (result.rowCount >= 0)
      {
        var enumerator = result.enumerate();
        enumerator.first();
        var pseudocode = enumerator.getVariant(0);
        document.getElementById("searchfield-new-name").setAttribute('value',enumerator.getVariant(1));
        var sql_text = document.getElementById("evm-search-textbox-query");
        try{sql_text.setAttribute("value",evmSearchGenerateGetSQL(pseudocode,false));}catch(err){}
      }
    }
    catch(ex)
    {
    }
	evmSearchBuildMask(pseudocode);
	evmSearchFieldDropdownEvent();
	evmChangePaneTo(5);
//	evmRefreshView(threadtreename, foldertreename);
	evmInitializeEVM();
//	categorytree.view.selection.select(categoryindex);
}


  // *************************************************************************
  // function:		evmDeleteSearch()
  // status:		finished
  // author:		Andr Grothues
  // *************************************************************************
  // deletes a search routine
function evmDeleteSearch()
{
  try
  {
	var searchtree = document.getElementById("evmEVMWindowMailviewFolderpaneboxSearchtree");
	var selectedSearch = evmGetAllSelectedTreeitems("evmEVMWindowMailviewFolderpaneboxSearchtree",false);
	var currentindex = searchtree.treeBoxObject.view.getIndexOfItem(selectedSearch[0]);

	var id = "id='" + selectedSearch[0].getAttribute("DBid") + "' ";
	var currentlevel = searchtree.treeBoxObject.view.getLevel(currentindex);
	currentindex++;
	try
	{
      while (searchtree.treeBoxObject.view.getLevel(currentindex)>currentlevel)
	  {
	  	id = id + "OR id='" + searchtree.treeBoxObject.view.getItemAtIndex(currentindex).getAttribute("DBid") + "' ";
	  	currentindex++;
	  }
	}
	catch(err)
	{}
	if (confirm("Do you really want to delete this search routine including ALL its sub-routines!?") == true)
	{
		var query = "DELETE FROM search WHERE " + id;
		try{connection.executeQuery(query);} catch(err) {};
		evmRefreshView("evmEVMWindowMailviewThreadpaneMailtree", "evmEVMWindowMailviewFolderpaneboxCategorytree");
		evmInitializeEVM();
		categorytree.view.selection.select(1);
	}
  }
  catch(err)
  {}
}




// **************************************************************************
// ********************** END of EVM-XUL Functions **************************
// **************************************************************************